/****************************************************************************
**
** Copyright (C) 2021 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
**
** This file is part of the QtPositioning module of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:COMM$
**
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company. For licensing terms
** and conditions see https://www.qt.io/terms-conditions. For further
** information use the contact form at https://www.qt.io/contact-us.
**
** $QT_END_LICENSE$
**
**
**
**
**
**
**
**
**
**
**
**
**
**
**
**
**
**
**
****************************************************************************/

#ifndef QGEOLOCATION_P_H
#define QGEOLOCATION_P_H

//
//  W A R N I N G
//  -------------
//
// This file is not part of the Qt API.  It exists purely as an
// implementation detail.  This header file may change from version to
// version without notice, or even be removed.
//
// We mean it.
//

#include <QtCore/QSharedData>
#include <QtPositioning/QGeoAddress>
#include <QtPositioning/QGeoCoordinate>
#include <QtPositioning/QGeoRectangle>
#include <QVariantMap>

QT_BEGIN_NAMESPACE

class QGeoLocationPrivate : public QSharedData
{
public:
    QGeoLocationPrivate();
    QGeoLocationPrivate(const QGeoLocationPrivate &other);

    ~QGeoLocationPrivate();

    bool operator==(const QGeoLocationPrivate &other) const;

    bool isEmpty() const;

    QGeoAddress address;
    QGeoCoordinate coordinate;
    QGeoRectangle viewport;
    QVariantMap extendedAttributes;
};

QT_END_NAMESPACE

#endif
